--/**
-- * param slotNumber int The number of the item in the active tech tab to build
-- * param shiftKey int If the shift key should be pressed (1) or not (0)
-- */
globalBuildslotsVar= {}
function buildSlot(slotNumber, shiftKey)

	-- if user clicked with mouse, un-highlight all buttons
	local uimain = import('/lua/ui/uimain.lua')
	globalBuildslotsMouseclickFunc = function(event)
		for _, button in globalBuildslotsVar do
			if(button.tooltipID)
			then	
				button:SetTexture(button.mNormal)
			end
		end
		uimain.RemoveOnMouseClickedFunc(globalBuildslotsMouseclickFunc)
	end
	
	-- un-highlight all buttons (in case of selecting another one without mouse clicking)
	for _, button in globalBuildslotsVar do
		if(button.tooltipID)
		then	
			button:SetTexture(button.mNormal)
		end
	end		
	
	-- click and highlight selected button
	local itemNumber= 0
	local construction = import('/lua/ui/game/construction.lua')
	local items = import('/lua/ui/game/construction.lua').controls.choices.Items
	for _, button in items do
		if(button.tooltipID)
		then
			itemNumber= itemNumber+1
			if(slotNumber == itemNumber) 
			then
				globalBuildslotsVar= items
				modifiers= { ['Left']= true }
				if(shiftKey == 1) then
					modifiers['Shift']= true
				end
				button:OnClick(modifiers)
				-- fixme: highlighting doesen't work with template tab
				if construction.GetCurrentTechTab() ~= 5 then
					button:SetTexture(button.mAltHighlight)
					uimain.AddOnMouseClickedFunc(globalBuildslotsMouseclickFunc)
				end
				return
			end
		end
	end
end


local construction = import('/lua/ui/game/construction.lua')

--/**
-- * helper for switchTechTab()
-- */
function switchHighestTechTab()
	for i=4,1,-1 do
		if not construction.GetTabByID('t'..i):IsDisabled() then
			construction.GetTabByID('t'..i):OnClick({Left = true})
			break
		end
	end
end

--/**
-- * switches between the template tab and the highest tech tab
-- */
function switchTechTab()
	local techTab= construction.GetCurrentTechTab();
    if techTab == 5 then
    	switchHighestTechTab()
    elseif 1 <= techTab < 5 then
    	construction.GetTabByID('templates'):OnClick({Left = true})
    end
end